unit edit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, StdCtrls, Grids, ValEdit, MyIniFiles, XPStyleActnCtrls,
  ActnList, ActnMan, Functions;

type
  TTtb_ed_main = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    N1: TMenuItem;
    Close1: TMenuItem;
    About1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Symbols: TValueListEditor;
    GroupBox3: TGroupBox;
    GroupBox4: TGroupBox;
    translit: TValueListEditor;
    Sample: TEdit;
    Information: TMemo;
    SampleOut: TLabel;
    SaveAs1: TMenuItem;
    ActionManager1: TActionManager;
    procedure Open1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure InformationKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Close1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure SymbolsKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure translitKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    procedure LoadTTB (FileName:string);
    Procedure SaveTTb (FileName:string);
    { Public declarations }
  end;

var
  Ttb_ed_main: TTtb_ed_main;
  TTBFILE:string;
  TTBTMP:string;
  Saved:boolean=true;
implementation

{$R *.dfm}

procedure TTtb_ed_main.LoadTTB(FileName: string);
var
INI:TIniFile;
S:TStringList;
I:Integer;
begin
try
INI:=TIniFile.Create(FileName);
S:=TStringList.Create;
INI.ReadSection('Symbols',S);
For I:=0 to S.Count-1 do
 begin
 Symbols.InsertRow(S[I],INI.ReadString ('Symbols',S[I],'',true),True);
 end;
S.Clear;
INI.ReadSection('Translit',S);
For I:=0 to S.Count-1 do
 begin
 Translit.InsertRow(S[I],INI.ReadString ('Translit',S[I],'',true),True);
 end;
S.Clear;
INI.ReadSection ('INFORMATION',S);
For I:=0 to S.Count-1 do
 begin
 Information.Lines.Add (INI.ReadString ('Information',S[I],'',true));
 end;
S.Free;
INI.Free;
except
on E: Exception do
 begin

 end;
end;
end;

procedure TTtb_ed_main.Open1Click(Sender: TObject);
begin
If not saved then
 begin
 Case MessageBox (Application.Handle,'Save changes?','Open',MB_YESNOCANCEL+MB_ICONQUESTION) of
  ID_YES: Save1.Click;
//  ID_NO: TTb_ed_main.Close;
  ID_CANCEL: exit;
 end;
 end;

If (OpenDialog1.Execute) and (OpenDialog1.FileName <>'')then
 begin
 Saved:=true;

 Symbols.Strings.Clear;
 Translit.Strings.Clear;

 TTBFILE:=OpenDialog1.FileName;
 TTBTMP:=ChangeFileExt (TTBFILE,'.tmp');
 LoadTTB (TTBFILE);
 Ttb_ed_main.Caption :='TTB Editor ['+TTBFILE+']';
 SampleOut.caption:=SymTranslit (Sample.Text,TTBTMP);
 end;
end;

procedure TTtb_ed_main.Save1Click(Sender: TObject);
begin
If TTBFILE='' then  SaveAs1.Click else
 begin
 SaveTTB (TTBFILE);
 Saved:=true;
 end;
end;

procedure TTtb_ed_main.SaveTTb(FileName: string);
var
INI:TIniFile;
I:Integer;
begin
INI:=TIniFile.Create(FileName);
INI.WriteString ('Information','1','ttb');
For I:=1 to Information.Lines.Count do
 begin
 if Information.Lines.Strings [i]<>'' then INI.WriteString('Information',IntTosTr(i),Information.Lines.Strings [i]);
 end;
For I:=1 to Symbols.RowCount-1 do
 begin
 if (Symbols.Keys [i]<>'') and (Symbols.Values [Symbols.Keys [i]]<>'') then INI.WriteString('Symbols',Symbols.Keys [i] ,Symbols.Values [Symbols.Keys [i]]);
 end;
For I:=1 to Translit.RowCount-1 do
 begin
 if (Translit.Keys [i]<>'') and (Translit.Values [Symbols.Keys [i]]<>'') then INI.WriteString('Translit',Translit.Keys [i] ,Translit.Values [Translit.Keys [i]]);
 end;
INI.Free;
end;

procedure TTtb_ed_main.SaveAs1Click(Sender: TObject);
Begin
If (SaveDialog1.Execute) and (SaveDialog1.FileName <>'')then
 begin
 Saved:=true;
 TTBFILE:=SaveDialog1.FileName;
 SaveTTB (TTBFILE);
 Ttb_ed_main.Caption :='TTB Editor ['+TTBFILE+']';
 end;
end;

procedure TTtb_ed_main.InformationKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
Saved:=False;
SaveTTB (TTBTMP);
SampleOut.caption:=SymTranslit (Sample.Text,TTBTMP);
end;

procedure TTtb_ed_main.Close1Click(Sender: TObject);
begin
Close;
end;

procedure TTtb_ed_main.About1Click(Sender: TObject);
begin
MessageBox (Application.Handle,'TTB files editor for Total Commander Translit.wdx plugin','About',MB_OK+MB_ICONINFORMATION);
end;

procedure TTtb_ed_main.SymbolsKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
If Shift=[ssCtrl] then
 begin
 if key=VK_ADD then Symbols.InsertRow ('New substr','',true);
 if key=VK_SUBTRACT then
  begin
  if Symbols.RowCount >2 then Symbols.DeleteRow(Symbols.Row);
  end;
 end;
end;

procedure TTtb_ed_main.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
If not saved then
 begin
 Case MessageBox (Application.Handle,'Save changes?','Exit',MB_YESNOCANCEL+MB_ICONQUESTION) of
  ID_YES: Save1.Click;
//  ID_NO: TTb_ed_main.Close;
  ID_CANCEL: Action:=caNone;
 end;
 end;
end;

procedure TTtb_ed_main.translitKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
If Shift=[ssCtrl] then
 begin
 if key=VK_ADD then Translit.InsertRow ('New char','',true);
 if key=VK_SUBTRACT then
  begin
  if Translit.RowCount >2 then Translit.DeleteRow(Translit.Row);
  end;
 end;
end;

procedure TTtb_ed_main.FormCreate(Sender: TObject);
begin
TTBTMP:=ChangeFileExt (Application.ExeName,'.tmp');
end;

end.
