library wdx_translit;

uses
SysUtils,
windows,
IniFiles,
Functions,
Classes,
Tag_types;

{$R *.res}
{$E wdx}


 var
x:pchar;
PluginPath:String;
Gsr:TSearchrec;
//GSearchNum:byte;
ColumnNames:TStrings;



SetF:TIniFile;

Function FindFirstNextClose (var sr:TSearchRec;searchnum:Integer):boolean;
var
FindNum:Integer;
begin
FindNum:=0;
result:=true;
if SearchNum=0 then
 begin
 //first ttb file
 if FindFirst(includetrailingbackslash (extractfiledir (PluginPath))+'*.ttb', faAnyFile, sr) <> 0 then
  begin
  //no ttb files found
  result:=false;
  SysUtils.FindClose (sr);
  end;
 end else
 begin
 //some else ttb files
 FindFirst(includetrailingbackslash (extractfiledir (PluginPath))+'*.ttb', faAnyFile, sr);
 while FindNum<>SearchNum do
  begin
  if FindNext (sr)=0 then
   begin
   inc (FindNum);
   end else
   begin
   result:=false;
   break;
   end;
  end;
  SysUtils.FindClose (sr);
//
 end;
end;
{------------------------------------------------------------------------------}
procedure ContentGetDetectString(DetectString:pchar;maxlen:integer); stdcall;
 Begin
 End;
{------------------------------------------------------------------------------}
function ContentGetSupportedField(FieldIndex:integer;FieldName:pchar;Units:pchar;maxlen:integer):integer; stdcall;
Begin
Case FieldIndex of
 0: Begin
    Strlcopy (FieldName,'(INT) Rus2lat',maxlen-1);
    result:=ft_string;
    End;
 1: Begin
    Strlcopy (FieldName,'(INT) Lat2rus',maxlen-1);
    result:=ft_string;
    End;
 2: Begin
    Strlcopy (FieldName,'(INT) Translit',maxlen-1);
    result:=ft_string;
    end;
 3: Begin
    Strlcopy (FieldName,'(INT) Fonetics',maxlen-1);
    result:=ft_string;
    end;
 4: Begin
    Strlcopy (FieldName,'(INT) MP3 ID3 Tag Rus2Lat',maxlen-1);
    result:=ft_string;
    end;
 5: Begin
    Strlcopy (FieldName,'FILE TRANSLITERATION',maxlen-1);
    result:=ft_string;
    end;
 else result:=0;
    begin
    if FindFirstNextClose (Gsr,FieldIndex-6) then
     begin
     Strlcopy (FieldName,pchar ('(USR) '+ChangeFileExt (gsr.Name,'')),maxlen-1);
     ColumnNames.Add(gsr.Name);
     result:=ft_string;
     end else result:=0;
    end;

end;



strcopy (units,'');
End;
{------------------------------------------------------------------------------}
function ContentGetValue(FileName:pchar;FieldIndex,UnitIndex:integer;FieldValue:pbyte;maxlen,flags:integer):integer; stdcall;
var
reslt:string;
Begin
if not directoryexists (FileName) then reslt:=ChangeFileExt(ExtractFileName(FileName),'') else reslt:=ExtractFilename(FileName);

case FieldIndex of
 0: Begin
    StrlCopy (Pchar(FieldValue),pchar(rus2lat (reslt)),maxlen-1);
    End;
 1: Begin
    StrlCopy (Pchar(FieldValue),pchar(lat2rus (reslt)),maxlen-1);
    End;
 2: Begin
    StrlCopy (Pchar(FieldValue),pchar(translit (reslt)),maxlen-1);
    End;
 3: Begin
    StrlCopy (Pchar(FieldValue),pchar(lat2RusF (reslt)),maxlen-1);
    End;
 4: Begin
    if (Lowercase(ExtractFileExt (FileName))<>'.mp3') and settings.Mp3Enable then
    StrlCopy (Pchar(FieldValue),'',maxlen-1)
    else StrlCopy (Pchar(FieldValue),pchar(TagRus2Lat (FileName,Settings.mp3ttbused)),maxlen-1)
    End;
 5: Begin
    StrlCopy (Pchar(FieldValue),pchar('<ONLY FOR CHANGE ATTRIBUTES>'),maxlen-1);
    End;
 else
   if Settings.UseMulti then StrlCopy (Pchar(FieldValue),pchar(SymTranslit (reslt,IncludeTrailingBackSlash(ExtractFilePath(PluginPath))+ColumnNames.Strings [FieldIndex-6])),maxlen-1)
   else
   StrlCopy (Pchar(FieldValue),pchar(TranslitUser (reslt,IncludeTrailingBackSlash(ExtractFilePath(PluginPath))+ColumnNames.Strings [FieldIndex-6])),maxlen-1);
 end;
result:=ft_string;
End;
{------------------------------------------------------------------------------}
procedure ContentSetDefaultParams(dps:pContentDefaultParamStruct); stdcall;
 Begin
 dps.PluginInterfaceVersionLow:=5;
 dps.PluginInterfaceVersionHi :=1;
 End;
(*{------------------------------------------------------------------------------}
function ContentGetDefaultSortOrder(FieldIndex:integer):integer; stdcall;
 Begin
 End;
{------------------------------------------------------------------------------}*)

function TranslitFile (InputFile,OutputFile,CodeTable:PChar):integer; stdcall;
var
f1,f2:Text;
buf,buf2:String;
Begin
AssignFile (f1,strpas(InputFile));
reset(f1);
AssignFile (f2,strpas(OutputFile));
rewrite (f2);
reset(f2);
append (f2);
while not EOF(F1) do
 begin
 ReadLn (F1,buf);
 if length(buf)>256 then
  begin
  while length(buf)>256 do
   begin
   buf2:=copy(buf,0,255);
   buf:=copy (buf,256,length(buf)-1);
   if Settings.UseMulti then
    begin
    buf2:=SymTranslit (buf2,strpas(Codetable))
    end else
    begin
    buf2:=TranslitUser (buf2,strpas(Codetable));
    end;
   write (f2,buf2);
   end;
  end;// else
//  begin
  if Settings.UseMulti then
   begin
   buf:=SymTranslit (buf,strpas(Codetable))
   end else
   begin
   buf:=TranslitUser (buf,strpas(Codetable));
   end;
  writeln (f2,buf);
// end;
End;
CloseFile (f1);
CloseFile (f2);
end;

function ContentGetSupportedFieldFlags(FieldIndex:integer):integer; stdcall;
Begin
result:=0;
if FieldIndex =-1 then Result:=contflags_edit+contflags_substmask;
if FieldIndex=5 then result:=contflags_edit+contflags_fieldedit;
end;

function ContentSetValue(FileName:pchar;FieldIndex,UnitIndex,FieldType:integer; FieldValue:pbyte;flags:integer):integer; stdcall;
Begin
 MessageBox (hInstance,FileName,'',0);
End;

function ContentEditValue(handle:thandle;FieldIndex,UnitIndex,FieldType:integer; FieldValue:pchar;maxlen:integer;flags:integer;langidentifier:pchar):integer; stdcall;
Begin

End;

{------------------------------------------------------------------------------}
exports
       ContentGetDetectString,
       ContentGetSupportedField,
       ContentGetValue,
       TranslitFile,
       ContentSetDefaultParams,
       ContentGetSupportedFieldFlags,
       ContentSetValue,
//       ContentSendStateInformation,
       ContentEditValue;
{       ContentGetDefaultSortOrder;}


begin
GetMem (x,max_path);
GetModuleFilename (hInstance,x,max_path);
PluginPath:=x;
ColumnNames:=TStringList.Create;
SetF:=TIniFile.Create(IncludeTrailingBackSlash(extractfilepath (PluginPath))+'wdx_translit.ini');
Settings.UseMulti:=SetF.ReadBool('Main','UseMulti',true);
Settings.ConvertSpaces :=SetF.ReadBool('Main','ConvertSpaces',false);
Settings.Mp3Enable:=SetF.ReadBool('mp3','Enable',true);
Settings.mp3ttbused :=IncludeTrailingBackSlash(extractfilepath (PluginPath))+SetF.ReadString('Mp3','ttbused','');
if not fileexists (Settings.mp3ttbused) then settings.mp3ttbused :='';
Settings.Mp3Id3v2:=SetF.ReadBool('Mp3','id3v2',true);
Settings.Format :=SetF.ReadString('Mp3','format','%artist% - %title%');
SetF.Free;
end.
